###############################################################################
# Post.pl                                                                     #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

$postplver = "1 Gold - SP 1.1";
# --- Added for Notify Plus 2.2 --- #
require "$sourcedir/NotifyPlus.pl";
# --- /Added for Notify Plus 2.2 --- #


sub Check_Board_Type {
	my($num) = $_[0];
	fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.dat");
	@blah = <FILE>;
	fclose(FILE);
	chomp($blah[3]);
	chomp($blah[4]);
	if (!$num) {
		if ($blah[3] == 1) {
			if ($username eq 'Guest') {
				&fatal_error("Sorry, only members may start threads on this board.");
			}
		} elsif ($blah[3] == 2) {
			if ($settings[7] ne 'Administrator' && !exists $moderators{$username}) {
				&fatal_error("Sorry, only admins and moderators may start threads on this board.");
			}
		}
	} else {
		if ($blah[4] == 1) {
			if ($username eq 'Guest') {
				&fatal_error("Sorry, only members may reply on this board.");
			}
		} elsif ($blah[4] == 2) {
			if ($settings[7] ne 'Administrator' && !exists $moderators{$username}) {
				&fatal_error("Sorry, only admins and moderators may reply on this board.");
			}
		}
	}
}
sub Post {
	if($username eq 'Guest' && $enable_guestposting == 0) { &fatal_error($txt{'165'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	my($filetype_info, $filesize_info);
	my( $subtitle, $x, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $msubject, $mattach, $mip, $mmessage, $mns, $quotestart);
	my $quotemsg = $INFO{'quote'};
	$threadid = $INFO{'num'};

	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$yyThreadLine);
	if( $mstate == 1 ) { &fatal_error($txt{'90'}); }

	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$cat = <FILE>;
	fclose(FILE);
	$curcat = $cat;
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	fclose(FILE);

	&Check_Board_Type($threadid);
# --- Deleted for Notify Plus 2.2 --- #
#	$notification = ! $enable_notification || $username eq 'Guest' ? '' : <<"~;";
#   <tr>
#      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
#     <td class="windowbg"><input type=checkbox name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
#   </tr>
#~;
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	# Notification enabled ?
	if ($enable_notification == 1) {

		# Notification enabled for guests ?
		if ($username ne 'Guest' || $enable_notification_guest == 1) {

			$notification = <<"~;";
    <tr>
      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
      <td class="windowbg"><font size=2><input type=checkbox name="notify" value="x"></font>
~;

			# When Guest
			if ($username eq 'Guest') {

				$notification .= <<"~;";

	<font size=1>$notify_txt{'1'}</font>
	<input type="radio" name="notifyformat" value="HTML" checked><font size=1>$notify_txt{'2'}</font>
	<input type="radio" name="notifyformat" value="Plain"><font size=1>$notify_txt{'3'}</font>
~;
			}
			# When Member
			else {

				$notification .= <<"~;";

	<font size=1>$txt{'750'}</font>
~;
			}

			$notification .= <<"~;";
	</td>
</tr>
~;
		}
	}
# --- /Added for Notify Plus 2.2 --- #


	$name_field = $realname eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'44'}:</b></font></td>
    <td class="windowbg"><input type=text name="name" size=25 value="$FORM{'name'}" maxlength="25" tabindex="2"></td>
      </tr>~ : qq~~;

	$email_field = $realemail eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'69'}:</b></font></td>
    <td class="windowbg"><font size="2"><input type=text name="email" size=25 value="$FORM{'email'}" maxlength="40" tabindex="3"></font></td>
      </tr>~ : qq~~;

	$sub = "";
	$settofield="subject";
	if( $threadid ne '' ) {
		fopen(FILE, "$datadir/$threadid.txt") || &fatal_error("201 $txt{'106'}: $txt{'23'} $threadid.txt");
		@messages = <FILE>;
		fclose(FILE);

		if($quotemsg ne '') {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns) = split(/\|/,$messages[$quotemsg]);
			$message=$mmessage;
### hide mod
			if( $message =~ /\[hide\]/)
			{
			$message =~ s/\[hide\](.+?)\[\/hide\]/\[HIDDEN]/g;
			}
### hide mod
			$message =~ s~<br>~\n~g;
			$message =~ s~\n{0,1}\[quote([^\]]*)\](.*?)\[/quote\]\n{0,1}~\n~isg;
			$message =~ s~\n*\[/*quote([^\]]*)\]\n*~~ig;

			$mname ||= $musername || $txt{'470'};
			$quotestart = int( $quotemsg / $maxmessagedisplay ) * $maxmessagedisplay;
			$message = qq~[quote author=$mname link=board=$currentboard;num=$threadid;start=$quotestart#$quotemsg date=$mdate\]$message\[/quote\]\n~;
			$msubject =~ s/\bre:\s+//ig;
			if ($mns eq "NS") {$nscheck="checked";}
		}
		else {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattache, $mip, $mmessage, $mns) = split(/\|/,$messages[0]);
			$msubject =~ s/\bre:\s+//ig;
		}
		$sub = "Re: $msubject";
		$settofield="message";
	}
	if(!$sub) { $subtitle = "<i>$txt{'33'}</i>"; }
	else { $subtitle = "<i>$sub</i>"; }
	$yymain .= qq~
<table  width="90%" align="center" cellpadding=0 cellspacing=0>
  <tr>
    <td valign=bottom colspan="2">
    <font size=2 class="nav"><B><img src="$imagesdir/open.gif" border=0>&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <img src="$imagesdir/tline.gif" border=0><IMG SRC="$imagesdir/open.gif"  border=0>&nbsp;&nbsp;
    <a href="$scripturl#$curcat" class="nav">$cat</a><br>
    <img src="$imagesdir/tline2.gif" border=0><IMG SRC="$imagesdir/open.gif" border=0>&nbsp;&nbsp;
    <a href="$cgi" class="nav">$boardname</a><br>
    <img SRC="$imagesdir/tline3.gif" border=0><IMG SRC="$imagesdir/open.gif" border=0>&nbsp;&nbsp;
    $INFO{'title'} ( $subtitle )</td>
  </tr>
</table>
~;
	$submittxt = "$txt{'105'}";
	$destination = "post2";
	$icon = "xx";
	$waction = "post";
	$post = "post";
	$preview = "preview";
	$yytitle = "$INFO{'title'}";
	&Postpage;
	&doshowthread;
	&template;
	exit;
}

sub Postpage {
&themen;
	my $extra;
	my($filetype_info, $filesize_info);
	$filetype_info = $checkext == 1 ? qq~$fatxt{'2'} @ext~ : qq~$fatxt{'2'} $fatxt{'4'}~;
	$filesize_info = $limit != 0 ? qq~$fatxt{'3'} $limit KB~ : qq~$fatxt{'3'} $fatxt{'5'}~;
	if ($FORM{'waction'} =~ /preview/) {$txt{'507'}=$txt{'771'};}
	if($waction eq "imsend") {
		if(!$INFO{'to'}) { $INFO{'to'} = $FORM{'to'};}
		if($INFO{'to'}) {$settofield="message";} else {$settofield="to";}
		$idinfo = "$INFO{'id'}";
		$extra = qq~
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'150'}</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}">
	<input type=text name="to" value="$INFO{'to'}" size="20" maxlength="50" tabindex="2">
	<font size="1">$txt{'748'}</font></td>
      </tr>
	~;

	}
	else {
	 $extra = qq~
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'71'}:</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}">
        <select name="icon" onChange="showimage()">
         <option value="xx"$ic1>$txt{'281'}
         <option value="thumbup"$ic2>$txt{'282'}
         <option value="thumbdown"$ic3>$txt{'283'}
         <option value="exclamation"$ic4>$txt{'284'}
         <option value="question"$ic5>$txt{'285'}
         <option value="lamp"$ic6>$txt{'286'}
         <option value="smiley"$ic7>$txt{'287'}
         <option value="angry"$ic8>$txt{'288'}
         <option value="cheesy"$ic9>$txt{'289'}
         <option value="laugh"$ic10>$txt{'290'}
         <option value="sad"$ic11>$txt{'291'}
         <option value="wink"$ic12>$txt{'292'}
        </select>
        <img src="$imagesdir/$icon.gif" name="icons" border=0 hspace=15></td>
      </tr>
	 ~;
	if ($realname eq '' && $threadid ne '') {$settofield="name";}
	}
	$yymain .= qq~
<table border=0 width="90%" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td bgcolor="$color{'bordercolor'}">
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
    <form action="$cgi;action=$destination" method="post" name="postmodify" ENCTYPE="multipart/form-data" onSubmit="submitonce(this);">
    <input type="hidden" name="threadid" value="$threadid">
    <input type=hidden name="postid" value="$postid">
<!--- Added for Notify Plus 2.2 --->
~;

# Add extra Fields when not Guest
if ($username ne 'Guest') {

	$yymain .= qq~
	<input type="hidden" name="name" value="$realname">
	<input type="hidden" name="email" value="$realemail">
~;

}

$yymain .= qq~
<!--- /Added for Notify Plus 2.2 --->

    <input type=hidden name="info" value="$idinfo">
    <table class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
      <tr>
        <td><font size=2 class="text1" color="$color{'titletext'}"><b>$yytitle</b></font></td>
      </tr>
    </table>
    </td>
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'70'}:</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><input type=text name="subject" value="$sub" size="40" maxlength="50" tabindex="1"></font></td>
      </tr>
$name_field
$email_field
$extra
$out
    </table>
    </td>
   </tr>
~;
if($enable_ubbc && $showyabbcbutt) {
	$yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg2'}" class="windowbg2">
      <tr>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$txt{'252'}:</b></font></td>
        <td valign=middle class="windowbg2" bgcolor="$color{'windowbg2'}">
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3)) {
          document.write("<a href=javascript:bold()><img src='$imagesdir/bold.gif' align=bottom width=23 height=22 alt='$txt{'253'}' border=0></a>");
          document.write("<a href=javascript:italicize()><img src='$imagesdir/italicize.gif' align=bottom width=23 height=22 alt='$txt{'254'}' border='0'></a>");
          document.write("<a href=javascript:underline()><img src='$imagesdir/underline.gif' align=bottom width=23 height=22 alt='$txt{'255'}' border='0'></a>");
          document.write("<a href=javascript:strike()><img src='$imagesdir/strike.gif' align=bottom width=23 height=22 alt='$txt{'441'}' border='0'></a>");
          document.write("<a href=javascript:glow()><img src='$imagesdir/glow.gif' align=bottom width=23 height=22 alt='$txt{'442'}' border='0'></a>");
          document.write("<a href=javascript:shadow()><img src='$imagesdir/shadow.gif' align=bottom width=23 height=22 alt='$txt{'443'}' border='0'></a>");
          document.write("<a href=javascript:move()><img src='$imagesdir/move.gif' align=bottom width=23 height=22 alt='$txt{'439'}' border='0'></a>");
          document.write("<a href=javascript:pre()><img src='$imagesdir/pre.gif' align=bottom width=23 height=22 alt='$txt{'444'}' border='0'></a>");
          document.write("<a href=javascript:left()><img src='$imagesdir/left.gif' align=bottom width=23 height=22 alt='$txt{'445'}' border='0'></a>");
          document.write("<a href=javascript:center()><img src='$imagesdir/center.gif' align=bottom width=23 height=22 alt='$txt{'256'}' border='0'></a>");
          document.write("<a href=javascript:right()><img src='$imagesdir/right.gif' align=bottom width=23 height=22 alt='$txt{'446'}' border='0'></a>");
          document.write("<a href=javascript:hr()><img src='$imagesdir/hr.gif' align=bottom width=23 height=22 alt='$txt{'531'}' border='0'></a>");
          document.write("<a href=javascript:size()><img src='$imagesdir/size.gif' align=bottom width=23 height=22 alt='$txt{'532'}' border='0'></a>");
          document.write("<a href=javascript:font()><img src='$imagesdir/face.gif' align=bottom width=23 height=22 alt='$txt{'533'}' border='0'></a>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        <select name="color" onChange="showcolor(this.options[this.selectedIndex].value)">
         <option value="Black" selected>$txt{'262'}</option>
         <option value="Red">$txt{'263'}</option>
         <option value="Yellow">$txt{'264'}</option>
         <option value="Pink">$txt{'265'}</option>
         <option value="Green">$txt{'266'}</option>
         <option value="Orange">$txt{'267'}</option>
         <option value="Purple">$txt{'268'}</option>
         <option value="Blue">$txt{'269'}</option>
         <option value="Beige">$txt{'270'}</option>
         <option value="Brown">$txt{'271'}</option>
         <option value="Teal">$txt{'272'}</option>
         <option value="Navy">$txt{'273'}</option>
         <option value="Maroon">$txt{'274'}</option>
         <option value="LimeGreen">$txt{'275'}</option>
        </select>
        <br>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3)) {
          document.write("<a href=javascript:flash()><img src='$imagesdir/flash.gif' align=bottom width=23 height=22 alt='$txt{'433'}' border='0'></a>");
          document.write("<a href=javascript:hyperlink()><img src='$imagesdir/url.gif' align=bottom width=23 height=22 alt='$txt{'257'}' border='0'></a>");
          document.write("<a href=javascript:ftp()><img src='$imagesdir/ftp.gif' align=bottom width=23 height=22 alt='$txt{'434'}' border='0'></a>");
          document.write("<a href=javascript:image()><img src='$imagesdir/img.gif' align=bottom width=23 height=22 alt='$txt{'435'}' border='0'></a>");
          document.write("<a href=javascript:emai1()><img src='$imagesdir/email2.gif' align=bottom width=23 height=22 alt='$txt{'258'}' border='0'></a>");
          document.write("<a href=javascript:table()><img src='$imagesdir/table.gif' align=bottom width=23 height=22 alt='$txt{'436'}' border='0'></a>");
          document.write("<a href=javascript:trow()><img src='$imagesdir/tr.gif' align=bottom width=23 height=22 alt='$txt{'437'}' border='0'></a>");
          document.write("<a href=javascript:tcol()><img src='$imagesdir/td.gif' align=bottom width=23 height=22 alt='$txt{'449'}' border='0'></a>");
          document.write("<a href=javascript:superscript()><img src='$imagesdir/sup.gif' align=bottom width=23 height=22 alt='$txt{'447'}' border='0'></a>");
          document.write("<a href=javascript:subscript()><img src='$imagesdir/sub.gif' align=bottom width=23 height=22 alt='$txt{'448'}' border='0'></a>");
          document.write("<a href=javascript:teletype()><img src='$imagesdir/tele.gif' align=bottom width=23 height=22 alt='$txt{'440'}' border='0'></a>");
          document.write("<a href=javascript:showcode()><img src='$imagesdir/code.gif' align=bottom width=23 height=22 alt='$txt{'259'}' border='0'></a>");
          document.write("<a href=javascript:quote()><img src='$imagesdir/quote2.gif' align=bottom width=23 height=22 alt='$txt{'260'}' border='0'></a>");
          document.write("<a href=javascript:list()><img src='$imagesdir/list.gif' align=bottom width=23 height=22 alt='$txt{'261'}' border='0'></a>");

	document.write("<a href=javascript:hide()><img src='$imagesdir/hide.gif' align=bottom width=23 height=22 alt='Top Secret' border='0'></a>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
<script>
function smiliewin() {
  window.open("$scripturl?action=smilieput", 'list', 'width=$color{'wdetach'},height=$color{'hdetach'}');
}
</script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr>
~;
}
else {
	$yymain .= qq~
      <tr>
        <td bgcolor="$color{'bordercolor'}" colspan="2">
        <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
~;
}
	$yymain .= qq~
      <tr>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$txt{'297'}:</b></font></td>
        <td valign=middle class="windowbg2" bgcolor="$color{'windowbg2'}">
<script language="JavaScript1.2" type="text/javascript">
<!--
~;
if ($detach ne 1){
	$i=0;
	while($SmilieURL[$i]) {
		$yymain .= qq~
function Smilie$i() {
AddTxt=" $SmilieCode[$i]";
AddText(AddTxt);
}~;
		$i++
	}
	}
$yymain .= qq~
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
          document.write("<a href=javascript:smiley()><img src='$imagesdir/smiley.gif' align=bottom alt='$txt{'287'}' border='0'></a> ");
          document.write("<a href=javascript:wink()><img src='$imagesdir/wink.gif' align=bottom alt='$txt{'292'}' border='0'></a> ");
          document.write("<a href=javascript:cheesy()><img src='$imagesdir/cheesy.gif' align=bottom alt='$txt{'289'}' border='0'></a> ");
          document.write("<a href=javascript:grin()><img src='$imagesdir/grin.gif' align=bottom alt='$txt{'293'}' border='0'></a> ");
          document.write("<a href=javascript:angry()><img src='$imagesdir/angry.gif' align=bottom alt='$txt{'288'}' border='0'></a> ");
          document.write("<a href=javascript:sad()><img src='$imagesdir/sad.gif' align=bottom alt='$txt{'291'}' border='0'></a> ");
          document.write("<a href=javascript:shocked()><img src='$imagesdir/shocked.gif' align=bottom alt='$txt{'294'}' border='0'></a> ");
          document.write("<a href=javascript:cool()><img src='$imagesdir/cool.gif' align=bottom alt='$txt{'295'}' border='0'></a> ");
          document.write("<a href=javascript:huh()><img src='$imagesdir/huh.gif' align=bottom alt='$txt{'296'}' border='0'></a> ");
          document.write("<a href=javascript:rolleyes()><img src='$imagesdir/rolleyes.gif' align=bottom alt='$txt{'450'}' border='0'></a> ");
          document.write("<a href=javascript:tongue()><img src='$imagesdir/tongue.gif' align=bottom alt='$txt{'451'}' border='0'></a> ");
          document.write("<a href=javascript:embarassed()><img src='$imagesdir/embarassed.gif' align=bottom alt='$txt{'526'}' border='0'></a> ");
          document.write("<a href=javascript:lipsrsealed()><img src='$imagesdir/lipsrsealed.gif' align=bottom alt='$txt{'527'}' border='0'></a> ");
          document.write("<a href=javascript:undecided()><img src='$imagesdir/undecided.gif' align=bottom alt='$txt{'528'}' border='0'></a> ");
          document.write("<a href=javascript:kiss()><img src='$imagesdir/kiss.gif' align=bottom alt='$txt{'529'}' border='0'></a> ");
          document.write("<a href=javascript:cry()><img src='$imagesdir/cry.gif' align=bottom alt='$txt{'530'}' border='0'></a> ");
~;
if ($detach ne 1){
	$i=0;
	while($SmilieURL[$i]) {
		$yymain .= qq~document.write("<a href=javascript:Smilie$i()><img src='$imagesdir/$SmilieURL[$i]' align=bottom alt='$SmilieDescription[$i]' border='0'></a>$SmilieLinebreak[$i] ");~;
	$i++;
	}
}
	$yymain .= qq~
}
else { document.write("<font size=1>$txt{'215'}</font>"); }
//-->
</script>
~;
if ($detach == 1){
	$yymain .= qq~
<a href=javascript:smiliewin()>More smilies</a>
~;
}
$yymain .= qq~        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr><tr>
        <td valign=top class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$txt{'72'}:</b></font></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">
                <textarea name="message" rows="12" cols="60" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" tabindex="4">$message</textarea>
        <br><a href="javascript:checklength(document.postmodify);">&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp(click here to check the message length)</a>
        </font><BR></td>
      </tr>
~;
# File Attachment's Browse Box Code
if ($allowattach == 1 && ($action eq 'post' || $action eq 'post2') && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) {
$yymain .= qq~
<tr>
	<td valign="top"><font size=2><b>$fatxt{'6'}</b></font></td>
	<td><input type="file" name="file" size="49"></td>
</tr>
<tr>
	<td align="right"></td>
	<td><font size="1">$filetype_info<br>$filesize_info</font></td>
</tr>
~;
if( ($FORM{'waction'} =~ 'preview') && ($FORM{'file'}) ) {
$yymain .= qq~
<tr>
	<td align="right"></td>
	<td><font size="1" color="#FF0000">$fatxt{'7'}</font></td>
</tr>
~;
}

}
# /File Attachment's Browse Box Code
$yymain .= qq~
    </table>
    </td>
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
$notification
$lastmod
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'276'}:</b></font><BR><BR></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><input type=checkbox name="ns" value="NS"$nscheck> <font size="1"> $txt{'277'}</font><BR><BR></td>
      </tr>
    </table>
    </td>
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}">
	 ~;
	if ($username ne 'Guest') {
	$yymain .= qq~
    <table class="titlebg" bgcolor="$color{'titlebg'}" align="center" width="100%">
      <tr>
        <td align="center">
        <font size="1" class="text1" color="$color{'titletext'}"><font size="1">$txt{'329'}</font></font><BR>
		<input type="hidden" name="waction" value="$waction">
		<input type="submit" name="$post" value="$submittxt" onClick="WhichClicked('$post');" accesskey="s" tabindex="5">
		<input type="submit" name="$preview" value="$txt{'507'}" onClick="WhichClicked('$preview');" accesskey="p">
		<input onclick="DoSpell('postmodify', 'message')" type="button" value="Check Spelling" name="SpellChk.x">
		~;
		}
	else {
	$yymain .= qq~
    <table class="titlebg" bgcolor="$color{'titlebg'}" align="center" width="100%">
      <tr>
        <td align="center">
        <font size="1" class="text1" color="$color{'titletext'}"><font size="1">$txt{'329'}</font></font><BR>
		<input type="hidden" name="waction" value="$waction">
		<input type="submit" name="$post" value="$submittxt" onClick="WhichClicked('$post');" accesskey="s" tabindex="5">
		<input type="submit" name="$preview" value="$txt{'507'}" onClick="WhichClicked('$preview');" accesskey="p">
		~;
		}
unless ($FORM{'waction'} =~ /preview/){$yymain .= qq~		<input type="reset" value="$txt{'278'}" accesskey="r">~;}

$yymain.=qq~
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<FORM name=SPELLDATA>
        <P><FONT face="Times New Roman, Times, serif">
		<INPUT type=hidden name=formname>
		<INPUT type=hidden name=messagebodyname>
		<INPUT type=hidden name=companyID> 
        <INPUT type=hidden name=language>
		<INPUT type=hidden name=opener>
		<INPUT type=hidden name=formaction> 
        </FONT></P>
</FORM>
<script language="JavaScript"> <!--
   document.postmodify.$settofield.focus();
//--> </script>
~;
}

sub Preview {
	if($FORM{'thema'}) {
	$b=1; $c=0;
	fopen(FILE, "$boardsdir/themen.sub");
	@subj = <FILE>;
	fclose(FILE);
	foreach $lines (@subj) {
	chomp($lines);
	if ($lines eq "$FORM{'thema'}") { $issub[$b] = " selected"; }
	$b++; $c++;
	}
	}
	&clear_temp;
	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$sub = $FORM{'subject'};
	$mess = $FORM{'message'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	$notify = $FORM{'notify'};
	$postid = $FORM{'postid'};
	if (length($subject) > 50) { $sub = substr($subject,0,50); }
	&ToHTML($sub);
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1$2~g;
	&ToHTML($message);
	$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$message =~ s/\n/<br>/g;
	&CheckIcon;

	if($icon eq "xx") { $ic1 = " selected"; }
	elsif($icon eq "thumbup") { $ic2 = " selected"; }
	elsif($icon eq "thumbdown") { $ic3 = " selected"; }
	elsif($icon eq "exclamation") { $ic4 = " selected"; }
	elsif($icon eq "question") { $ic5 = " selected"; }
	elsif($icon eq "lamp") { $ic6 = " selected"; }
	elsif($icon eq "smiley") { $ic7 = " selected"; }
	elsif($icon eq "angry") { $ic8 = " selected"; }
	elsif($icon eq "cheesy") { $ic9 = " selected"; }
	elsif($icon eq "laugh") { $ic10 = " selected"; }
	elsif($icon eq "sad") { $ic11 = " selected"; }
	elsif($icon eq "wink") { $ic12 = " selected"; }

	$name_field = $realname eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'44'}:</b></font></td>
    <td class="windowbg"><input type=text name="name" size=25 value="$FORM{'name'}" maxlength="25" tabindex="2"></td>
      </tr>~ : qq~~;

	$email_field = $realemail eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'69'}:</b></font></td>
    <td class="windowbg"><input type=text name="email" size=25 value="$FORM{'email'}" maxlength="40" tabindex="3"></td>
      </tr>~ : qq~~;
	if ($FORM{'notify'} eq "x") {$notify = " checked";}
	if ($FORM{'ns'} eq 'NS') {$nscheck = " checked";}

	if ($username eq 'Guest') {
		fopen(FILE, "$memberdir/memberlist.txt") || &fatal_error("202 $txt{'106'}: $txt{'23'} memberlist.txt");
		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $name;
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				$tmpa = <FILE2>;
				$realname = <FILE2>;
				fclose(FILE2);
				chomp $realname;
				$realname = lc $realname;
				if ($realname eq $testname || $membername eq $testname) { &fatal_error($txt{'100'}); }
			}
			elsif( $testname eq $membername ) { &fatal_error($txt{'100'}); }
		}
		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("203 $txt{'106'}: $txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("204 $txt{'106'}: $txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for( $a = 0; $a < @reservecfg; $a++ ) {
			chomp $reservecfg[$a];
		}
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $name : lc $name;
		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
	}
	&wrap;
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	&wrap2;
	if( $FORM{'waction'} eq 'previewmodify' ) {
		$submittxt = "$txt{'10'}";
		$waction = "postmodify";
		$post = "postmodify";
		$preview = "previewmodify";
		$destination = 'modify2';
		$submittxt = $txt{'10'};
	}
	elsif( $FORM{'waction'} eq 'previewim' ) {
		$submittxt = "$txt{'148'}";
		$destination = "imsend2";
		$waction = "imsend";
		$post = "imsend";
		$preview = "previewim";
		$submittxt = $txt{'148'};
	}
	else {
		$notification = ! $enable_notification || $username eq 'Guest' ? '' : <<"~;";
    <tr>
      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
      <td class="windowbg"><input type=checkbox name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
    </tr>
~;
		$destination = 'post2';
		$submittxt = $txt{'105'};
		$waction = "post";
		$post = "post";
		$preview = "preview";
	}

	$csubject = $sub;
	&LoadCensorList;	# Load Censor List
	$csubject =~ s/\Q$tmpa\E/$tmpb/gi;
	$message =~ s/\Q$tmpa\E/$tmpb/gi;

	$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript" src="$ubbcjspath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
<table border=0 width="90%" cellspacing=1 cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}">
    <img src="$imagesdir/$icon.gif" name="icons" border=0> $csubject</font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><BR>$message<BR><BR></font></td>
  </tr>
</table>
<BR>
~;
	$message = $mess;
	$yytitle = "$txt{'507'} - $csubject";
	$settofield="message";
	&Postpage;
	&template;
	exit;
}

sub Post2 {
	if($username eq 'Guest' && $enable_guestposting == 0) {	&fatal_error($txt{'165'}); }
	&Check_Board_Type($FORM{'threadid'});
	my( $email, $subject, $ns, $threadid, $notify, @memberlist, $a, $realname, $membername, $testname, @reserve, @reservecfg, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, $newthreadid, @messages, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $start, $pageindex, $tempname );

	# If poster is a Guest then evaluate the legality of name and e-mail
	if(!$settings[2]) {
		$FORM{'name'} =~ s/\A\s+//;
		$FORM{'name'} =~ s/\s+\Z//;
		&fatal_error($txt{'75'}) unless ($FORM{'name'} ne '' && $FORM{'name'} ne '_' && $FORM{'name'} ne ' ');
		&fatal_error($txt{'568'}) if(length($FORM{'name'}) > 25);
		&fatal_error("$txt{'76'}") if($FORM{'email'} eq '');
		&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($FORM{'email'} !~ /^[0-9A-Za-z@\._\-]+$/);
		&fatal_error("$txt{'500'}") if(($FORM{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($FORM{'email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
	}

	# Get the form values
	$thema = $FORM{'thema'};
	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$subject = $FORM{'subject'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	if( $threadid =~ /\D/ ) { &fatal_error($txt{'337'}); }
	$notify = $FORM{'notify'};

	if($name && $email) {
		&ToHTML($name);
		$email =~ s/\|//g;
		&ToHTML($email);
		$tempname = $name;	# hold it temporarily so we can put the _'s back later
		$name =~ s/\_/ /g;
	}

	&fatal_error($txt{'75'}) unless($username || $name);
	&fatal_error($txt{'76'}) unless($settings[2] || $email);
	&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~);
	&fatal_error($txt{'78'}) unless($message);
	if (length($message)>$MaxMessLen) { &fatal_error($txt{'499'}); }

	if( $FORM{'waction'} =~ 'preview' ) { &Preview; }
	&spam_protection;

	if (length($subject) > 50) { $subject = substr($subject,0,50); }
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($subject);
	&ToHTML($message);
	$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$message =~ s~\n~<br>~g;
	&CheckIcon;

	if(-e("$datadir/.txt")) { unlink("$datadir/.txt"); }

	if ($username ne 'Guest') {
		# If not guest, get name and email.
		$name = $settings[1];
		$email = $settings[2];
	} else {
		# If user is Guest, then make sure the chosen name
		# is not reserved or used by a member.
		fopen(FILE, "$memberdir/memberlist.txt") || &fatal_error("206 $txt{'106'}: $txt{'23'} $memberlist.txt");

		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $name;
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				$tmpa = <FILE2>;
				$realname = <FILE2>;
				fclose(FILE2);
				chomp $realname;
				$realname = lc $realname;
				if ($realname eq $testname || $membername eq $testname) { &fatal_error($txt{'473'}); }
			}
			elsif( $testname eq $membername ) { &fatal_error($txt{'473'}); }
		}

		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("207 $txt{'106'}: $txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("208 $txt{'106'}: $txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for( $a = 0; $a < @reservecfg; $a++ ) { chomp $reservecfg[$a]; }
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $name : lc $name;

		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
		$name = $tempname; # put the name back (with any _'s) now that we've checked it
	}



######################################
## File Attachment Mod v2.3         ##
######################################

if ($FORM{'file'}) {
if ($FORM{'waction'} ne 'post') { &write_error("$fatxt{'49'}"); }
$mylimit = 1024 * $limit;
$mydirlimit = 1024 * $dirlimit;

$file = $filename;
$file =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;
$file =~ s/[#%+,\/:?"<>'|@^]//g;	#edit in between [ ] to include characters you dont want to allow in filenames (dont put a . there or you wont be able to get any file extensions).
$file =~ s/ /_/g;			#replaces spaces in filenames with a "_" character.

opendir(AMD, $upload_dir) || &write_error("$fatxt{'19'} $upload_dir.");
@dirlist = readdir(AMD);
closedir(AMD);

foreach $dirlist(@dirlist)
   {
          if ($dirlist eq $file) { &write_error("$fatxt{'8'}"); }

   }

if ($checkext == 0) { $match = 1; } else {
foreach $ext (@ext){
	chomp ($ext);
		if (grep /$ext$/i,$file){$match=1; last;}
	}
}
if ($match) {
	if ($allowattach == 1 && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) { 
		$upload_okay = 1;
	}
} else {
		&write_error("$fatxt{'20'} @ext"); 
	}

if ($mydirlimit > 0) {
	&dirstats;
}

$filesize = $ENV{'CONTENT_LENGTH'} - $postsize;
$filesizekb = int ($filesize/1024);
if ($filesize > $mylimit && $mylimit != 0) {
	$filesizediff = $filesizekb - $limit;
	if ($filesizediff == 1) { $sizevar = "kilobyte"; } else { $sizevar = "kilobytes"; }
	&write_error("$fatxt{'21'} $filesizediff $sizevar $fatxt{'21b'}");
} elsif ($filesize > $spaceleft && $mydirlimit != 0) {	
	$filesizediff = $filesizekb - $kbspaceleft;
	if ($filesizediff == 1) { $sizevar = "kilobyte"; } else { $sizevar = "kilobytes"; }
	&write_error("$fatxt{'22'} $filesizediff $sizevar $fatxt{'22b'}");
}

$write_file = "$upload_dir/$file";
$save_file = "$http_dir/$file"; 

}

#######################################
## /File Attachment Mod v2.3         ##
#######################################	

	# If no thread specified, this is a new thread.
	# Find a valid random ID for it.
	if($threadid eq '') {
		$newthreadid = time;
		$i=0;
		if (-e "$datadir/$newthreadid.txt") {
			while (-e "$datadir/$newthreadid$i.txt") { ++$i; }
			$newthreadid="$newthreadid$i";
		}
	}
	else { $newthreadid = ''; }

	if($newthreadid) {
		# This is a new thread. Save it.
				fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.dat");
		@mailcheck = <FILE>;
		fclose(FILE);
		chomp($mailcheck[6]);
		if($mailcheck[6] eq "1") {
		# Mail webmaster about new post
		$mailsub = "A new thread has been started, $subject. On board: $mailcheck[0] It's located here:\n $cgi;action=display;num=$newthreadid";
		$board = $INFO{'board'};
		&sendmail( $webmaster_email, "$board. New Thread: $subject", $mailsub);
		}

fopen(FILE, "+<$boardsdir/$currentboard.txt") || &write_error("210 $txt{'106'}: $txt{'23'} $currentboard.txt");
		seek FILE, 0, 0;
		fopen(TEMP, "+>$boardsdir/$currentboard.txt.temp") || &fatal_error("209 $txt{'106'}: $txt{'23'} $boardsdir/$currentboard.txt.temp");
		while( read(FILE,$buffer,1024) ) { print TEMP $buffer; }
		seek TEMP, 0, 0;
		truncate FILE, 0;
		seek FILE, 0, 0;
		print FILE qq~$newthreadid|$subject|$name|$email|$date|0|$username|$icon|0\n~;
		while( read(TEMP,$buffer,1024) ) { print FILE $buffer; }
		fclose(TEMP);
		if (-e "$boardsdir/$currentboard.txt.temp") { unlink("$boardsdir/$currentboard.txt.temp"); }
		fclose(FILE);
		fopen(FILE, ">$datadir/$newthreadid.txt") || &write_error("$txt{'23'} $newthreadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||$save_file|$file\n~;
		fclose(FILE);
		$mreplies = 0;
		if ($file) {
		fopen(AMP, ">>$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP qq~$newthreadid|$mreplies|$subject|$name|$currentboard|$filesizekb|$date|$file\n~;
		fclose(AMP);
		}
	} else {
		# This is an old thread. Save it.
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$yyThreadLine);
		if( $mstate == 1 ) { &fatal_error($txt{'90'}); }
		++$mreplies;
		fopen(FILE, "+<$boardsdir/$currentboard.txt") || &write_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
		seek FILE, 0, 0;
		fopen(TEMP, "+>$boardsdir/$currentboard.txt.temp") || &fatal_error("209 $txt{'106'}: $txt{'23'} $boardsdir/$currentboard.txt.temp");
		seek TEMP, 0, 0;
		while( read(FILE,$buffer,1024) ) {
			print TEMP $buffer;
		}
		truncate FILE, 0;
		seek FILE, 0, 0;
		print FILE qq~$mnum|$msub|$mname|$memail|$date|$mreplies|$musername|$micon|$mstate\n~;
		seek TEMP, 0, 0;
		my $new_count = 0;
		while( $line = <TEMP> ) {
			unless($new_count == $yyThreadPosition) { print FILE $line; }
			$new_count++;
		}
		fclose(TEMP);
		if (-e "$boardsdir/$currentboard.txt.temp") { unlink("$boardsdir/$currentboard.txt.temp"); }
		fclose(FILE);
		fopen(FILE, ">>$datadir/$threadid.txt") || &write_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||$save_file|$file\n~;
		fclose(FILE);
		if ($file) {
		fopen(AMP, ">>$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP qq~$mnum|$mreplies|$subject|$name|$currentboard|$filesizekb|$date|$file\n~;
		fclose(AMP);
		}
	}

	if($username ne 'Guest') {
		# Increment post count for the member.
		$settings[6] =~ s/[\n\r]//g;
		++$settings[6];
		fopen(FILE, ">$memberdir/$username.dat") || &fatal_error("213 $txt{'106'}: $txt{'23'} $username.dat");
		foreach (@settings) {
			print FILE qq~$_\n~;
		}
		fclose(FILE);
	}

	# The thread ID, regardless of whether it's a new thread or not.
	$thread = $newthreadid || $threadid;

# --- Added for Notify Plus 2.2 --- #
	# Write new Post for Mailinglist
	if ($enable_mailinglist == 1) {

		# Check if thread ID is already written in New posts File before
		$idfound = 0;
		fopen(FILE, "$vardir/newposts.txt");
		@newposts = <FILE>;
		fclose (FILE);

		foreach $newpost (@newposts) {

			chomp($newpost);
			local($board, $newpostid, $date) = split(/\|/, $newpost);
				if ($thread eq $newpostid) { $idfound =1; }
		}

		# Write thread ID in New posts File, when not written before
		if ($idfound == 0) {
			fopen(FILE, ">>$vardir/newposts.txt");
			print FILE "$currentboard|$thread|$date\n";
			fclose (FILE);
		}
	}
# --- /Added for Notify Plus 2.2 --- #

	# Update totals for this board.
	&doaddition;

# --- Deleted for Notify Plus 2.2 --- #
#	# Notify any members who have notification turned on for this thread.
#	if(-e("$datadir/$thread.mail")) { &NotifyUsers; }
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	# Notify any members who have notification turned on for this thread.
	if(-e("$datadir/$thread.mail")) { &NotifyUsers('thread'); }

	# Notify any members who have notification turned on for the board this thread is in.
	elsif ($enable_notification_board && -e("$boardsdir/$currentboard.mail")) {
		&NotifyUsers('board');
	}
# --- /Added for Notify Plus 2.2 --- #


	# Mark thread as read for the member.
	&dumplog($currentboard,$date);


######################################
## File Attachment Mod v2.3         ##
######################################
if ($upload_okay == 1) {
	if($servertype == 0) {
		fopen(AMT, ">$write_file")||&write_error("$fatxt{'19'} $write_file. $!");
		binmode AMT;
		# binmode is for windows only. Ignored by unix
		while ($bytesread=read($filename,$buffer,1024)) { print AMT $buffer; }
		fclose(AMT);	
		chmod (0666, "$write_file");
		close($filename);
		1;
	} elsif ($servertype == 1) {
		close($filename);
		rename $tmpfile, $write_file || &write_error("Error renaming '$tmpfile' to '$write_file'!");
		1;
	}
&clear_temp;
}
#######################################
## /File Attachment Mod v2.3         ##
#######################################

	# Let's figure out what page number to show
	$start = 0;
	$pageindex = int($mreplies / $maxmessagedisplay);
	$start = $pageindex * $maxmessagedisplay;
	if($thema ne "$esmtxt{'05'}") { &themenpost; }

# --- Deleted for Notify Plus 2.2 --- #
#	if($notify) {
#		$INFO{'thread'} = $thread;
#		$INFO{'start'} = $start;
#		require "$sourcedir/Notify.pl";
#		&Notify2;
#	}
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	if( $notify ) {
		$INFO{'thread'} = $thread;
		$INFO{'start'} = $start;
		require "$sourcedir/Notify.pl";
		
		# When guest
		if ($username eq 'Guest') {
			&Notify2("Guest");
		}
		# When Member
		else {
			&Notify2();
		}
	}	
# --- /Added for Notify Plus 2.2 --- #

	$yySetLocation = qq~$cgi;action=display;num=$thread;start=$start~;
	&redirectexit;
}

sub NotifyUsers {
# --- Added for Notify Plus 2.2 --- #

	# Type of posting
	local($post_type) = @_;
# --- /Added for Notify Plus 2.2 --- #

	$subject = $FORM{'subject'};

# --- Deleted for Notify Plus 2.2 --- #
#	fopen(FILE, "$datadir/$thread.mail") || return 0;
#	@mails = <FILE>;
#	fclose(FILE);
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	# Read Board-file
	@boardmails = ();
	if ($enable_notification_board && -e("$boardsdir/$currentboard.mail")) {
		fopen(FILE, "$boardsdir/$currentboard.mail") || return 0;
		@boardmails = <FILE>;
		fclose(FILE);
	}

	# Read Thread-file
	@threadmails = ();
	if(-e("$datadir/$thread.mail")) {
		fopen(FILE, "$datadir/$thread.mail") || return 0;
		@threadmails = <FILE>;
		fclose(FILE);
	}

	# Join both array's
	%usedemail = ();
	@mails = ();

	# Board-mails
	foreach $record (@boardmails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);

		# Push e-mail & format
		push(@mails, $record);

		# Save used e-mail-address
		$usedemail{"$email"} = $email;
	}

	# Thread-mails
	foreach $record (@threadmails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);

		if ($usedemail{"$email"} ne $email) {
			push(@mails, $record);
		}
	}
# --- /Added for Notify Plus 2.2 --- #

# --- Deleted for Notify Plus 2.2  --- #
#	foreach $curmail (@mails) {
#		chomp $curmail;
#		if ($curmail ne $settings[2]) {
#			&sendmail($curmail,"$txt{'127'}\:  $subject","$txt{'128'}, $subject, $txt{'129'} $cgi;action=display;num=$thread\n\n$txt{'130'}");
#		}
#	}
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	# Send the topic

	&NP_SendTopic($post_type);
# --- /Added for Notify Plus 2.2 --- #

	return 1;
}

sub doshowthread {
	my( $line, $trash, $tempname, $tempdate, $temppost );

	&LoadCensorList;	# Load Censor List

	if (@messages) {
		$yymain .= qq~
	<BR><BR>
	<table cellspacing=1 cellpadding=0 width="90%" align="center" bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr><td>
	<table class="windowbg" cellspacing=1 cellpadding=2 width=100% align=center bgcolor="$color{'windowbg'}">
	<tr><td class="titlebg" bgcolor="$color{'titlebg'}" colspan=2><font size=2 class="text1" color="$color{'titletext'}">
	<b>$txt{'468'}</b>
	</td></tr>~;
		foreach $line (@messages) { #start for each

			($trash, $tempname, $trash, $tempdate, $trash, $trash, $trash, $trash, $message, $ns) = split(/\|/,$line);
			$tempdate = &timeformat($tempdate);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$message =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			### hide mod
			if( $message =~ /\[hide\]/)
			{
		
			$message =~ s/\[hide\](.+?)\[\/hide\]/\[HIDDEN\]/g;

			}
			### hide mod
			my @words = split(/\s/,$message);
			&wrap;
			$displayname = $tempname;
			if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
			&wrap2;
			$yymain .= qq~

<tr><td align=left class="catbg">
<font size="1">$txt{'279'}: $tempname</font></td>
<td class="catbg" align=right>
<font size="1">$txt{'280'}: $tempdate</font></td>
</tr>
<tr><td class="windowbg2" colspan=2 bgcolor="$color{'windowbg2'}">
<font size="1">$message</font>
</td></tr>~;
		}
		$yymain .= "</table></td></tr></table>\n";
	}
	else { $yymain .= "<!--no summary-->"; }
}

sub doaddition {
	fopen(FILE, "+>$boardsdir/$currentboard.poster");
	print FILE $name;
	fclose(FILE);

	fopen(FILE2, "$datadir/$thread.data");
	$tempinfo = <FILE2>;
	fclose(FILE2);

	($views, $lastposter) = split(/\|/,$tempinfo);

	my( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($currentboard);
	++$messagecount;
	unless( $FORM{'threadid'} ) {
		++$threadcount;
	}
	$myname = $username eq 'Guest' ? qq~Guest-$name~ : $username;
	&BoardCountSet( $currentboard, $threadcount, $messagecount, $date, $myname );

	fopen(FILE2, "+>$datadir/$thread.data");
	print FILE2 "$views|$myname";
	fclose(FILE2);
}
sub themen {

fopen(FILE, "<$boardsdir/themen.sub");
@themen = <FILE>;
fclose(FILE);
$c=1;

fopen(FILE2, "<$boardsdir/$currentboard.sub");
$go = <FILE2>;
chomp $go;
fclose(FILE2);

if ($go == 1 || $go == 2 && $settings[7] eq "Administrator" || $go == 2 && exists $moderators{$username} || $go == 2 && $settings[7] eq "Global Moderator") {

if ($INFO{'num'} eq "") {
$out = qq~<tr><td class="windowbg" bgcolor="$color{'windowbg'}" width="23%">
	          <font size=2><b>$esmtxt{'06'}:</b></font></td>
	      <td class="windowbg" bgcolor="$color{'windowbg'}"><select name="thema"><option value="$esmtxt{'05'}"></option>~;

foreach $thema (@themen) {
chomp $thema;
if ($thema ne "") {
$out .= qq~<option value="$thema"$issub[$c]>$thema</option>~;
$c++;
}
}
$out .= qq~</select></td></tr>~;
} else { 
fopen(FILE, "<$datadir/$INFO{'num'}.sub");
	$thema3 = <FILE>;
	chomp $thema3;
	fclose(FILE);

$out = qq~<tr><td class="windowbg" bgcolor="$color{'windowbg'}" width="23%">
		<font size=2><b>$esmtxt{'06'}:</b></font></td>
	      <td class="windowbg" bgcolor="$color{'windowbg'}">
		<input type="thema" name="thema" value="$thema3"></td></tr>~;
}

} else { $out = "" }
}

sub themenpost {
fopen(FILE, "+>$datadir/$thread.sub");
	print FILE "$thema";
	fclose(FILE);
}

1;